/*
 * Implementation of the buddy/emoticon - images introduced in MSN6
 * -----------------------------------------------------------------
 * 
 * This is a rather quick-implementation and could probably be
 * optimized/corrected in many ways. But I don't even like MSN!
 * I just implemented this because ppl kept asking why I didn't
 * configure a buddy-image (they don't know what bitlbee is!). 
 *
 * So I decided to implement this stupid feature into bitlbee but
 * I don't realy care about if the code is good or bad. The good
 * thing is it's working and now ppl can see my face in their MSN
 * window... And I can see theirs, but like I said, I don't care :p
 *
 * Enjoy!
 *
 * Andy Knuts (irc://akke && email://djfred@poeperkesdag.be)
 *
 */
 
#include "nogaim.h"
#include "msn.h"
#include "msnc1.h"
#include "msnobject.h"

/*
 * Sets your buddy image to the one specified in the my_buddy_image
 * setting.
 */
void msn_update_mybuddyimage( struct gaim_connection *gc )
{
        struct msn_data *md = gc->proto_data;
        char *filename = set_getstr( gc->irc, "msn_images_mybuddyimage" );

        if ( filename && access( filename, R_OK ) == 0 )
        {
                if( md->msnobject )
                        g_free( md->msnobject );
                
                md->msnobject = msnobject_from_params( gc->username, TYPE_BUDDY_IMAGE, filename );
        }
        else
        {
                do_error_dialog(gc, "Could not create msnobject for my buddy image. Please check your 'my_buddy_image' setting!", "MSN");
        }
}

/*
 * returns the userinfo ( containing msnobject etc... ) for a given user
 */
struct msn_userinfo *msn_find_userinfo( struct msn_data *md, char *who )
{
        GSList *tmp = md->userinfolist;

        struct msn_userinfo *userinfo;

        while( tmp != NULL )
        {
                userinfo = ( struct msn_userinfo * ) tmp->data;
                if( !strcmp( userinfo->who, who ) )
                          return userinfo;

                tmp = g_slist_next( tmp );
        }

        return NULL;
}

/*
 * deletes all data from a msn_userinfo struct
 */
void msn_cleanup_userinfo( struct msn_userinfo *userinfo )
{
	if( userinfo->who )
	{
		g_free( userinfo->who );
		userinfo->who = NULL;
	}
	
	if( userinfo->msnobject )
	{
		g_free( userinfo->msnobject );
		userinfo->msnobject = NULL;
	}
}

/*
 * deleted all userinfo data from a msn_data struct
 */
void msn_cleanup_userinfolist( struct msn_data *md )
{
        GSList *tmp = md->userinfolist;
        if( tmp )
        {
                while( tmp != NULL )
                {
	         	msn_cleanup_userinfo(( struct msn_userinfo* )tmp->data );
		      	tmp = g_slist_next( tmp );
                }

                g_slist_free( md->userinfolist );
                md->userinfolist = NULL;
        }
}

/*
 * add or update an existing userinfo in md->userinfolist GSList
 */
void msn_add_or_update_userinfolist( struct gaim_connection *gc, struct msn_userinfo *new_userinfo )
{
        struct msn_userinfo *userinfo;
        struct msn_data *md = gc->proto_data;
        userinfo = msn_find_userinfo( md, new_userinfo->who );
        int user_buddyimage_changed = 0;
        if( userinfo )
        {
                if( userinfo->msnobject && new_userinfo->msnobject &&
                    strcmp(userinfo->msnobject, new_userinfo->msnobject) != 0 )
                {
                        user_buddyimage_changed = 1;
                }
                msn_cleanup_userinfo( userinfo );
                md->userinfolist = g_slist_remove( md->userinfolist, userinfo );
        }
        md->userinfolist = g_slist_append( md->userinfolist, new_userinfo );
        if( user_buddyimage_changed )
        {
                struct msn_switchboard *sb = msn_sb_by_handle( gc, new_userinfo->who );
                if( sb )
                {
                        p2p_request_msnobject(sb, sb->who, NULL, NULL );
                }
        }
}

/*
 * create a userinfo struct from the provided parameters
 */

struct msn_userinfo *userinfo_from_params( char *who, char *msnobject )
{
        struct msn_userinfo *userinfo;
        userinfo = g_new( struct msn_userinfo, 1 );

        if( !userinfo )
                return NULL;

        userinfo->who = g_strdup( who );
        userinfo->msnobject = g_strdup( msnobject );

        return userinfo;
}


/*
 * 2 stupid functions actually ...
 */
void p2p_init_random()
{
        srand( time( NULL ) );
}

DWORD p2p_randomnr()
{
        return rand();
}

/*
 * generate a random UID
 */
char *p2p_rand_guid()
{
	return g_strdup_printf( "%4X%4X-%4X-%4X-%4X-%4X%4X%4X",
		rand() % 0xAAFF + 0x1111, rand() % 0xAAFF + 0x1111,
		rand() % 0xAAFF + 0x1111, rand() % 0xAAFF + 0x1111,
		rand() % 0xAAFF + 0x1111, rand() % 0xAAFF + 0x1111,
		rand() % 0xAAFF + 0x1111, rand() % 0xAAFF + 0x1111 );
}

/*
 * create a P2PPacket and initialize it's members to the defauls...
 */
struct P2PPacket *p2p_packet_new()
{
        struct P2PPacket *packet = g_new0( struct P2PPacket, 1 );

	if( !packet )
		return NULL;
        
/*
        packet->destination = NULL;
        packet->filename = NULL;
        packet->call_id = NULL;
        packet->branch = NULL;
*/
        packet->fd = -1;

	return packet;
}

/*
 * convert a textbuffer containing a packet into a packet struct
 * ... returns NULL on error
 */
struct P2PPacket *p2p_packet_from_buffer( char *buffer, int length )
{
	int pos;
	struct P2PPacket *packet;

	if( length <( sizeof( struct P2PHeader ) + sizeof( struct P2PFooter ) ) )
		return NULL;

	packet = p2p_packet_new();
	if( !packet )
		return NULL;

	pos = 0;

        memcpy( &( packet->header ), buffer, sizeof( struct P2PHeader ) );
	pos += sizeof( struct P2PHeader );

	if( length < ( sizeof( struct P2PHeader ) + packet->header.length + sizeof( struct P2PFooter ) ) )
	{
		g_free( packet );
		return NULL;
	}

        if( packet->header.length > 0 )
        {
        	memcpy( packet->data, buffer+pos, packet->header.length );
                pos += packet->header.length;
        }

        memcpy( &( packet->footer ), buffer+pos, sizeof( struct P2PFooter ) );

	return packet;
}

/*
 * find p2p packet by call_id
 */
struct P2PPacket *p2p_find_packet_by_callid( struct msn_switchboard *sb, char *call_id )
{
        if( !call_id )
                return NULL;

        GSList *tmp = sb->p2p_sessionlist;
        
        struct P2PPacket *packet;

        while( tmp != NULL )
        {
                packet = ( struct P2PPacket * ) tmp->data;
                if( packet->call_id && 
                    !strcmp( packet->call_id, call_id ) )
                          return packet;
                          
                tmp = g_slist_next( tmp );
        }
        
        return NULL;
                
}

/*
 * find a session by type/value in the current session list of this sb
 */
struct P2PPacket *p2p_find_packet( struct msn_switchboard *sb, DWORD value, int type )
{
        GSList *tmp = sb->p2p_sessionlist;
        struct P2PPacket *packet;
        
        if( value == 0 )
                return NULL;
        
        while( tmp != NULL )
        {
                packet = ( struct P2PPacket * ) tmp->data;
                switch( type )
                {
                        case FIND_BY_SESSION_ID:
                                if( packet->header.session_id == value )
                                {
                                        return packet;
                                }
                                break;

                        case FIND_BY_ID:
                                if( packet->header.id == value )
                                {
                                        return packet;
                                }
                                break;

                        default:
                                return NULL;
                }
                              
                tmp = g_slist_next( tmp );
        }
        
        return NULL;
}

/*
 * extracts the given header from the packet slp data by doing
 * it's utmost best to find it!
 */
char *p2p_findheader( struct P2PPacket *packet, char *header )
{
        char *p, *tmp;

        p = msn_findheader( packet->data, header, packet->header.length );

        if( p )
                return p;

        tmp = strstr( packet->data, "\r\n\r\n" );
        while( tmp )
        {
                tmp += 4;

                p = msn_findheader( tmp, header, packet->header.length - ( tmp - packet->data ) );

                if( p )
                        return p;
                
                tmp = strstr( tmp, "\r\n\r\n" );
        }

        tmp = strstr( packet->data, header );

        if( tmp )
        {
		char *tmp2;
		tmp2 = strstr( tmp, "\r" );
		if( tmp2 )
		{
		        tmp += strlen( header );
			int length = ( tmp2-tmp );
                        p = g_new0( char, length+1 );
			if( !p )
				return NULL;
			strncpy( p, tmp, length );
			p[length]=0;
			return p;
		}
        }
        
        return NULL;
}

/*
 * free all properties of a P2PPacket
 */
void p2p_cleanup_packet( struct P2PPacket *packet )
{
	if( packet->destination )
	{
		g_free( packet->destination );
                packet->destination = NULL;
        }
		
	if( packet->branch )
	{
		g_free( packet->branch );
                packet->branch = NULL;
	}
	
	if( packet->call_id )
	{
		g_free( packet->call_id );
                packet->call_id = NULL;
        }
        
        if( packet->filename )
        {
                g_free( packet->filename );
                packet->filename = NULL;
        }
        
        if( packet->fd != -1 )
        {
                close( packet->fd );
                packet->fd = -1;
        }
}

/*
 * gets called from sb.c every time before the sb itself gets g_free()'s
 */
void p2p_cleanup_sb( struct msn_switchboard *sb )
{
        GSList *tmp;

        tmp = sb->p2p_sessionlist;

        if( tmp )
        {
                while( tmp != NULL )
                {
                        p2p_cleanup_packet(( struct P2PPacket * )tmp->data );
                        tmp = g_slist_next( tmp );
                }

                g_slist_free( sb->p2p_sessionlist );
                sb->p2p_sessionlist = NULL;
        }
}

/*
 * returns a fullpath for the requested image
 */
char *msn_imagefullpath( struct gaim_connection *gc, char *who, char *msnobject, int type, char *emoticon_shortcut, char *ext )
{
        char *path = NULL, *fullpath = NULL, *sha1c, *sha1d, md5[60], filename[150];
       	struct stat statinfo;
       	int buffersize;
        md5_state_t state;
        md5_byte_t digest[16];
        user_t *user;
        int i;

        switch( type )
        {
                case TYPE_BUDDY_IMAGE:
                        path = set_getstr( gc->irc, "msn_images_path_buddy" );
                        break;
                case TYPE_EMOTICON_IMAGE:
                        path = set_getstr( gc->irc, "msn_images_path_emoticon" );
                        break;
        }

        if( !path )
                return NULL;

      	if(( stat( path, &statinfo ) ) != 0 )
      	        return NULL;

        if( !S_ISDIR( statinfo.st_mode ) )
                return NULL;

        sha1c = msnobject_get_field( "SHA1C", msnobject );
	if( !sha1c )
	{
		do_error_dialog( gc, "Could not allocate memory for 'sha1c' in msn_imagefullpath()", "MSN" );
		return NULL;
        }

        sha1d = msnobject_get_field( "SHA1D", msnobject );
	if( !sha1d )
	{
		do_error_dialog( gc, "Could not allocate memory for 'sha1d' in msn_imagefullpath()", "MSN" );
		g_free( sha1c );
		return NULL;
	}
    
        md5_init( &state );
        md5_append( &state,( const md5_byte_t * ) sha1c, strlen( sha1c ) );
        md5_append( &state,( const md5_byte_t * ) sha1d, strlen( sha1d ) );
        md5_finish( &state, digest );

        g_free( sha1c );
        g_free( sha1d );

	bzero( md5, sizeof( md5 ) );

        for( i = 0; i < 16; i ++ )
	        g_snprintf( md5+strlen( md5 ), 3, "%02x", digest[i] );

	g_snprintf( filename, sizeof( filename ), "%s.%s", md5, ext );

        user = user_findhandle( gc, who );
        if ( user )
        {
                buffersize = strlen( path ) + 1 + strlen( who ) + 1 + strlen( filename );

                if( emoticon_shortcut )
                        buffersize += strlen( emoticon_shortcut );
              
                fullpath = g_new0( char, buffersize );
                       
                if ( fullpath )
                {
                        switch( type )
                        {
                                case TYPE_BUDDY_IMAGE:
                                        g_snprintf( fullpath, buffersize, "%s/%s.%s", path, user->nick, filename );
                                        break;
                                case TYPE_EMOTICON_IMAGE:
                                        g_snprintf( fullpath, buffersize, "%s/%s.emoticon.%s", path, user->nick, filename );
                                        break;
                        }
                }
                else
                {
                	do_error_dialog( gc, "Could not allocate memory for 'fullpath' in msn_imagefullpath()", "MSN" );
                }
        }
        else
        {
                do_error_dialog( gc, "Could not find userhandle in msn_imagefullpath()", "MSN" );
        }

        return fullpath;
}


/*
 * send packet 'packet' to the sb
 */
void p2p_sendpacket( struct msn_switchboard *sb, struct P2PPacket *packet )
{

        struct gaim_connection *gc = sb->gc;
        char cmd[1024], *buffer, *p;
        char *header;
        int len;

	if( !packet->destination )
	{
		do_error_dialog( gc, "Could not send packet in p2p_sendpacket(), no destination givven!", "MSN" );
		return;
	}
	
	header = "MIME-Version: 1.0\r\nContent-Type: application/x-msnmsgrp2p\r\nP2P-Dest: ";

	len = strlen( header ) +
	      strlen( packet->destination ) +
	      4 /* \r\n\r\n */ +
	      sizeof( struct P2PHeader ) +
	      sizeof( struct P2PFooter );
	      
	if( packet->header.length > 0 )
	        len += packet->header.length; /* length of packet->data */
        
        buffer = g_new0(char, len + 1);

        if (!buffer)
        {
		do_error_dialog( gc, "Could not allocate memory for 'buffer' in p2p_sendpacket()", "MSN" );
                return;
        }
        
        g_snprintf( buffer, len, "%s%s\r\n\r\n", header, packet->destination );
        p = buffer+strlen( buffer );
        
        memcpy( p, &( packet->header ), sizeof( struct P2PHeader ) );
        p += sizeof( struct P2PHeader );
        
        if( packet->header.length > 0 )
        {
                memcpy( p, packet->data, packet->header.length );
                p += packet->header.length;
        }
        
        memcpy( p, &( packet->footer ), sizeof( struct P2PFooter ) );
        p += sizeof( struct P2PFooter );

        g_snprintf( cmd, sizeof( cmd ), "MSG %d D %d\r\n", ++sb->trId, len );

        if( !( msn_sb_write( sb, cmd, strlen( cmd ) ) && msn_sb_write( sb, buffer, len ) ) )
        {
                do_error_dialog( gc, "Error writing to switchboard in p2p_sendpacket()", "MSN" );
        }
        
        g_free( buffer );

}


/*
 * Sends an ACK packet to the sb 
 */
void p2p_sendack( struct msn_switchboard *sb, struct P2PPacket *packet, struct P2PPacket *received_packet )
{
        if( !packet )
                return;

        packet->header.id++;
        packet->header.offset = 0;
	packet->header.total_size = received_packet->header.total_size;
        packet->header.length = 0;
	packet->header.flags = 0x2;
	packet->header.ack_sub_id = received_packet->header.ack_id;
        packet->header.ack_id = received_packet->header.id;
        packet->header.ack_size = received_packet->header.length;
        packet->footer.value = 0;

        p2p_sendpacket( sb, packet );
}

/*
 * Sends the base identifier packet to the sb
 */
void p2p_sendbaseidentifier( struct msn_switchboard *sb, struct P2PPacket *packet, struct P2PPacket *received_packet )
{
        if( !packet )
                return;

        packet->header.session_id = 0;
        packet->header.offset = 0;
	packet->header.total_size = received_packet->header.total_size;
	packet->header.flags = 0x2;
	packet->header.ack_sub_id = received_packet->header.ack_id;
	packet->header.ack_id = received_packet->header.id;
        packet->header.id = p2p_randomnr();
	packet->header.ack_size = received_packet->header.length;
        packet->header.length = 0;

        packet->footer.value = 0;

        p2p_sendpacket( sb, packet );

        packet->header.id -= 4;        
}

/*
 * Send's the "200 OK" message to the sb
 */
void p2p_send200ok( struct msn_switchboard *sb, struct P2PPacket *packet, struct P2PPacket *received_packet )
{
        struct gaim_connection *gc = sb->gc;
        char body[1024];

        if( !packet )
                return;

        packet->header.session_id = 0;
        packet->header.id++;
        packet->header.offset = 0;
        
        g_snprintf( body, sizeof( body ), "SessionID: %d\r\n\r\n", packet->session_id );
        
        bzero( packet->data, sizeof( packet->data ) );
        
        packet->header.total_size = g_snprintf( packet->data, sizeof( packet->data ),
                  "MSNSLP/1.0 200 OK\r\n"
                  "To: <msnmsgr:%s>\r\n"
                  "From: <msnmsgr:%s>\r\n"
                  "Via: MSNSLP/1.0/TLP ;branch={%s}\r\n"
                  "CSeq: %d\r\n"
                  "Call-ID: {%s}\r\n"
                  "Max-Forwards: 0\r\n"
                  "Content-Type: application/x-msnmsgr-sessionreqbody\r\n"
                  "Content-Length: %d\r\n\r\n"
                  "%s",
                  packet->destination, gc->username, packet->branch, ++packet->cseq, 
                  packet->call_id, strlen( body )+1 /*adding up the \x00 in the content-length*/ , body );

        packet->header.total_size++; /* we need the \x00 at the end  */
	packet->header.length = packet->header.total_size;
	packet->header.flags = 0;
	packet->header.ack_id = received_packet->header.id;
	packet->header.ack_sub_id = 0;
	packet->header.ack_size = 0;
	
        packet->footer.value = 0;

        p2p_sendpacket( sb, packet );
}

/*
 * Sends the DATA PREPARATION packet to the sb
 */
void p2p_senddataprep( struct msn_switchboard *sb, struct P2PPacket *packet )
{
        if( !packet )
                return;

        packet->header.session_id = packet->session_id;
        packet->header.id++;
        packet->header.offset = 0;
        packet->header.total_size = 4;
        packet->header.length = 4;
        packet->header.flags = 0;
        packet->header.ack_id = p2p_randomnr();
        packet->header.ack_sub_id = 0;
        packet->header.ack_size = 0;

        bzero( packet->data, sizeof( packet->data ) );

        packet->footer.value = 0x01000000;
        
        p2p_sendpacket( sb, packet );
}

/*
 * Sends data( picture data ) to the sb
 * splitting it into multiple messages if required
 */
void p2p_senddata( struct msn_switchboard *sb, struct P2PPacket *packet )
{
        int fd, bytes;
        struct stat fileinfo;
        
        if( !packet )
                return;

        if( !packet->filename )
                return;
                
        if( ( fd=open( packet->filename, O_RDONLY ) ) == -1 )
                return;
                
        if( fstat( fd, &fileinfo ) != 0 )
        {
                close( fd );
                return;
        }

        packet->header.id++;
        packet->header.total_size = fileinfo.st_size;
        packet->header.flags = 0x20;
        packet->header.ack_sub_id = 0;
        packet->header.ack_size = 0;
        packet->header.offset = 0;

        packet->footer.value = 0x01000000;

#define MAX_CHUNK_SIZE 1200
        while(( bytes = read( fd, packet->data, MAX_CHUNK_SIZE ) ) > 0 ) {
                packet->header.ack_id = p2p_randomnr();
                packet->header.length = bytes;
                p2p_sendpacket( sb, packet );
                packet->header.offset += packet->header.length;
        }
        
        close( fd );
}

/*
 * sends an INVITE for context to the packet's destination...
 */
void p2p_sendinvite( struct msn_switchboard *sb, struct P2PPacket *packet, char *context )
{
        struct gaim_connection *gc = sb->gc;
	char body[1024];

	packet->session_id = p2p_randomnr();

        if( packet->fd == -1 )
        {
                do_error_dialog( gc, "Couldn't send an INVITE because the current packet hasn't got an open file to write to! WTF?", "MSN" );
                return;
        }

        if( packet->branch )
        {
                g_free( packet->branch );
        }
	packet->branch = p2p_rand_guid();

	if( packet->call_id )
	{
	        g_free( packet->call_id );
        }
	packet->call_id = p2p_rand_guid();

        packet->header.session_id = 0;
        packet->header.id = p2p_randomnr();
        packet->header.offset = 0;

        g_snprintf( body, sizeof( body ), 
		"\r\n"
		"EUF-GUID: {A4268EEC-FEC5-49E5-95C3-F126696BDBF6}\r\n"
		"SessionID: %d\r\n"
		"AppID: 1\r\n"
		"Context: %s\r\n",
		packet->session_id, context );

	bzero( packet->data, sizeof( packet->data ) );

        packet->header.total_size = g_snprintf( packet->data, sizeof( packet->data ),
		"INVITE MSNMSGR:%s MSNSLP/1.0\r\n"
		"To: <msnmsgr:%s>\r\n"
		"From: <msnmsgr:%s>\r\n"
		"Via: MSNSLP/1.0/TLP ;branch={%s}\r\n"
		"CSeq: 0\r\n"
		"Call-ID: {%s}\r\n"
		"Max-Forwards: 0\r\n"
		"Content-Type: application/x-msnmsgr-sessionreqbody\r\n"
		"Content-Length: %d\r\n"
		"%s",
		packet->destination, packet->destination, gc->username, packet->branch, packet->call_id, strlen( body )+1, body );

	packet->header.total_size++;

        packet->header.length = packet->header.total_size;
        packet->header.flags = 0;
        packet->header.ack_id = p2p_randomnr();
        packet->header.ack_sub_id = 0;
        packet->header.ack_size = 0;

        packet->footer.value = 0;

	sb->p2p_sessionlist = g_slist_append( sb->p2p_sessionlist, packet );

	packet->next_step_on_ack = BASEIDENTIFIER;

        p2p_sendpacket( sb, packet );
}

/*
 * request an msnobject from a user, it'll convert the msnobject to a context for p2p_sendinvite()
 * makes a fullpath using msn_imagefullpath() and opens that file for writing, add the filedescriptor
 * to the packet and then sends the invite...
 * if emo_msnobject is NULL we'll request the user's buddy-image, else emo_msnobject 
 * is requested as an emoticon...
 */
void p2p_request_msnobject( struct msn_switchboard *sb, char *destination, char *emo_msnobject, char *emoticon_shortcut)
{
        struct gaim_connection *gc = sb->gc;
        struct msn_data *md = gc->proto_data;
        char *context = NULL, *msnobject = NULL;
        struct P2PPacket *packet;
        int type = -1;

        if( emo_msnobject == NULL ) /* we need to request the user's msnobject for buddy-image */
        {
                struct msn_userinfo *userinfo = msn_find_userinfo( md, destination );
                if( userinfo )
                {
                        msnobject = userinfo->msnobject;
        		context = msnobject_to_context( userinfo->msnobject );
        		type = TYPE_BUDDY_IMAGE;
                }
                else
                {
                        /* Requesting a buddy-image from a user that doesn't have one ???
                         * return! we shouldn't be doing anything then!
                         */
                        return;
                }
        }
        else /* We'll request an emoticon... */
        {
                msnobject = emo_msnobject;
                context = msnobject_to_context( emo_msnobject );
                type = TYPE_EMOTICON_IMAGE;
	}
	
        if( context )
        {
                packet = p2p_packet_new();

                if ( packet )
                {
                        char *filename = NULL;
                        char *emoticon_info_filename = NULL;
                        
                        packet->destination = g_strdup( destination );
                        switch( type )
                        {
                                case TYPE_BUDDY_IMAGE:
                                        filename = msn_imagefullpath( gc, packet->destination, msnobject, type, emoticon_shortcut, "png" );
                                        break;
                                case TYPE_EMOTICON_IMAGE:
                                        filename = msn_imagefullpath( gc, packet->destination, msnobject, type, emoticon_shortcut, "png" );
                                        if( emoticon_shortcut )
                                        {
                                                emoticon_info_filename = msn_imagefullpath( gc, packet->destination, msnobject, type, emoticon_shortcut, "emo" );
                                                if( emoticon_info_filename )
                                                {
                                                        FILE *fp;
                                                        fp = fopen( emoticon_info_filename, "w" );
                                                        if( fp )
                                                        {
                                                                fprintf( fp, "SHORTCUT=%s\n", emoticon_shortcut );
                                                                fprintf( fp, "PNGFILE=%s\n", filename );
                                                                fclose( fp );
                                                        }
                                                        else
                                                        {
                                                                do_error_dialog( gc, "Could not open this emoticon's .emo file for writing!!!", "MSN" );
                                                                g_free( filename );
                                                                filename = NULL;
                                                        }
                                                        g_free( emoticon_info_filename );
                                                        emoticon_info_filename = NULL;
                                                }
                                                else
                                                {
                                                        g_free( filename );
                                                        filename = NULL;
                                                }
                                        }
                                        else
                                        {
                                                /* This should never be reached! */
                                                do_error_dialog( gc, "Requesting TYPE_EMOTICON_IMAGE without a valid emoticon_shortcut", "MSN" );
                                        }
                                        break;
                                default: 
                                        /* In fact we should never reach this peace of code! */
                                        do_error_dialog( gc, "Requesting an unknown msnobject type? Not even trying that! ...", "MSN" );
                                        break;
                        }
                        
                        
                        if( filename )
                        {
                                if( emoticon_shortcut )
                                {
                                        char buffer[1024];
                                        int len = g_snprintf( buffer, sizeof( buffer ), 
                                                "<<bitlbee>> %s is an emoticon ( %s )",
                                                emoticon_shortcut, filename );
                                        serv_got_im( gc, destination, buffer, 0, 0, len );
                                }

                                if( access( filename, F_OK ) == 0 )
                                {
                                        /*switch( type )
                                        {
                                                case TYPE_BUDDY_IMAGE:
                                                        serv_got_crap( gc, "Not downloading buddy image from %s because we already have it cached!",
                                                                packet->destination );
                                                        break;
                                                case TYPE_EMOTICON_IMAGE:
                                                        serv_got_crap( gc, "Not downloading emoticon image from %s because we already have it cached!",
                                                                packet->destination );
                                                        break;
                                        }*/
                                }
                                else
                                {
                                        packet->fd = open( filename, O_WRONLY|O_TRUNC|O_CREAT, 00777 );
                                        
                                        if ( packet->fd != -1 )
                                        {
                                                if( packet->filename )
                                                {
                                                        g_free( packet->filename );
                                                }                                                        
                                                packet->filename = g_strdup( filename );
                                                packet->type = type;
                                     
                                                /* p2p_sendinvite will add packet to the md->p2p_sessionlist so it'll
                                                 * be g_free()'ed at the right time!
                                                 */
                                                p2p_sendinvite( sb, packet, context );
                                        }
                                }

                                g_free( filename );
                        }
                        else
                        {
                                switch( type )
                                {
                                        case TYPE_BUDDY_IMAGE:
                                                do_error_dialog( gc, "Please check your 'msn_images_path_buddy' setting. It doesn't seem to be a valid directory!", "MSN" );
                                                break;
                                        case TYPE_EMOTICON_IMAGE:
                                                do_error_dialog( gc, "Please check your 'msn_images_path_emoticon' setting. It doesn't seem to be a valid directory!", "MSN" );
                                                break;
                                }
                        }
                }
                else
                {
                        do_error_dialog( gc, "Could not allocate memory for 'packet' in p2p_request_msnobject()", "MSN" );
                }

                g_free( context );
        }
        else
        {
                do_error_dialog( gc, "Couldn't create context for msnobject in p2p_request_msnobject()", "MSN" );
        }

}

/*
 * Send BYE packet to sb
 */
void p2p_sendbye( struct msn_switchboard *sb, struct P2PPacket *packet, struct P2PPacket *received_packet )
{
        struct gaim_connection *gc = sb->gc;

        if( !packet )
                return;

	packet->header.session_id = 0;
        packet->header.id++;
        packet->header.offset = 0;

        bzero( packet->data, sizeof( packet->data ) );
        
        packet->header.total_size = g_snprintf( packet->data, sizeof( packet->data ),
                  "BYE MSNMSGR:%s MSNSLP/1.0\r\n"
                  "To: <msnmsgr:%s>\r\n"
                  "From: <msnmsgr:%s>\r\n"
                  "Via: MSNSLP/1.0/TLP ;branch={%s}\r\n"
                  "CSeq: 0\r\n"
                  "Call-ID: {%s}\r\n"
                  "Max-Forwards: 0\r\n"
                  "Content-Type: application/x-msnmsgr-sessionclosebody\r\n"
                  "Content-Length: 3\r\n\r\n",
                  packet->destination, packet->destination, gc->username, packet->branch, packet->call_id );

        packet->header.total_size++; /* we need a \x00 at the end! */
	packet->header.length = packet->header.total_size;

	packet->header.flags = 0;
        packet->header.ack_id = received_packet->header.id;
	packet->header.ack_sub_id = 0;
	packet->header.ack_size = 0;
	
        packet->footer.value = 0;
        
        p2p_sendpacket( sb, packet );
}

void log_packet(struct P2PPacket *packet, char *dir)
{
/*
FILE *fp;
fp=fopen("/tmp/log.akke","a");
fprintf(fp, "\r\n%s START-----------------------------------------------\r\n", dir);
fprintf(fp, "header:\n");
fprintf(fp, " session_id: %d\n", packet->header.session_id);
fprintf(fp, " id: %d\n", packet->header.id);
fprintf(fp, " offset: %llu\n", packet->header.offset);
fprintf(fp, " len: %llu\n", packet->header.total_size);
fprintf(fp, " length: %d\n", packet->header.length);
fprintf(fp, " flags: %d\n", packet->header.flags);
fprintf(fp, " ack_id: %d\n", packet->header.ack_id);
fprintf(fp, " ack_sub_id: %d\n", packet->header.ack_sub_id);
fprintf(fp, " ack_size: %llu\n", packet->header.ack_size);
if (packet->header.length > 0)
{
    fprintf(fp, "data:\n");
    fprintf(fp, "%s\n", packet->data);
}
fprintf(fp, "footer:\n");
fprintf(fp, " value: %d\n", packet->footer.value);
fprintf(fp, "\r\n%s STOP-----------------------------------------------\r\n", dir);
fclose(fp);
*/
}


/*
 * Main handler. Will parse all P2P/SLP messages and handle it appropriate..
 */
void p2p_handler( struct msn_switchboard *sb, struct P2PPacket *packet )
{
        struct gaim_connection *gc = sb->gc;
        struct P2PPacket *tmp_packet;

        log_packet(packet, "IN");
        /* if this is an ACK packet */
        if( packet->header.flags == 0x2 )
        {
                debug( "P2P: ACK received..." );

                /* Check if any of our sessions is waiting for an ACK */
                tmp_packet = p2p_find_packet( sb, packet->header.ack_id, FIND_BY_ID );
                if( tmp_packet )
                {
                        debug( "session found by FIND_BY_ID ..." );
                        switch( tmp_packet->next_step_on_ack )
                        {
                          /* Sending image part */
                                case DATA_PREP:
                                        debug( "Ok! Now sending data preparation..." );

                                        tmp_packet->next_step_on_ack = SEND_DATA;
                                        p2p_senddataprep( sb, tmp_packet );
                                        
                                        break;

                                case SEND_DATA:
                                        debug( "Ok! Now sending the data...");
                                        
                                        tmp_packet->next_step_on_ack = DATA_SENT;
                                        p2p_senddata( sb, tmp_packet );
                                        switch( tmp_packet->type )
                                        {
                                                case TYPE_BUDDY_IMAGE:
                                                        serv_got_crap( gc, "%s downloaded my buddy image!",
                                                                tmp_packet->destination );
                                                        break;
                                                case TYPE_EMOTICON_IMAGE:
                                                        serv_got_crap( gc, "%s downloaded my emoticon image!",
                                                                tmp_packet->destination );
                                                        break;
                                        }
                                       
                                        break;
                                        
                                case DATA_SENT:
                                        debug( "Ok! This is the data sent ack. Nothing to be done..." );
                                        tmp_packet->next_step_on_ack = -1;
                                        serv_got_crap( gc, "My buddy image successfully sent to %s",
                                                                        tmp_packet->destination );
                                        break;

                          /* Receiving image part */
				case BASEIDENTIFIER:
                                        debug( "Ok! This is the base identifier. Nothing to be done..." );
					break;
					
                                case BYEACK:
                                        debug( "Ok! This is an ACK to my bye msg. Deleting session..." );
                                        p2p_cleanup_packet( tmp_packet );
                                        sb->p2p_sessionlist = g_slist_remove( sb->p2p_sessionlist, tmp_packet );

                                        break;
                                        
                                default:
                                        debug( "huh? I don't expect any ACK!!! ERROR ERROR??" );
                                        break;
                        }
                }
                else
                {
                        debug( "hmm, i couldn't find a session for this ack. Ignoring packet...");
                        return; /* ignore ACK packet */
                }
        } else
        
        /* Check if this is an INVITE packet */
        if( !strncmp( packet->data, "INVITE MSNMSGR", strlen( "INVITE MSNMSGR" ) ) )
        {
                char *session_id = p2p_findheader( packet, "SessionID:" );
                char *dest = p2p_findheader( packet, "From: <msnmsgr:" );
                char *branch = p2p_findheader( packet, "branch={" );
                char *call_id = p2p_findheader( packet, "Call-ID: {" );
                char *cseq = p2p_findheader( packet, "CSeq:" );
                char *content_type = p2p_findheader( packet, "Content-Type:" );

                if( session_id && dest && branch && call_id && cseq && content_type )
                {
                        dest[strlen( dest )-1]=0;
                        branch[strlen( branch )-1]=0;
                        call_id[strlen( call_id )-1]=0;
                
                        if( !strncmp( content_type, "application/x-msnmsgr-sessionreqbody", strlen( "application/x-msnmsgr-sessionreqbody" ) ) )
                        {
                                char *eufguid = p2p_findheader( packet, "EUF-GUID: {" );
                                char *appid = p2p_findheader( packet, "AppID:" );
                                char *context = p2p_findheader( packet, "Context:" );
                                
                                if( eufguid && appid && context )
                                {
                                        eufguid[strlen( eufguid )-1]=0;
                        
                                        /* Check eufguid, A4268EEC-FEC5-49E5-95C3-F126696BDBF6 = emoticon or buddy image */
                                        if( !strncmp( eufguid, "A4268EEC-FEC5-49E5-95C3-F126696BDBF6", strlen( "A4268EEC-FEC5-49E5-95C3-F126696BDBF6" ) ) )
                                        {
                                                /* buddy image or emoticon */
                                                packet->destination = g_strdup( dest );
                                                packet->session_id = atoi( session_id );
                                                packet->fd = -1;
                                                packet->next_step_on_ack = -1;

                                                sb->p2p_sessionlist = g_slist_append( sb->p2p_sessionlist, packet );

                                                p2p_sendbaseidentifier( sb, packet, packet );
                                
                                                debug( "Sent base identifier...");
                                        }
                                        
                                  
                                        if( !strncmp( appid, "1", 1 ) )
                                        {
                                        //todo: check context, if it's a buddy or emoticon and if it's valid..
                                        //      then use msn_images_mybuddyimage and probably create a new
                                        //      option msn_images_myemoticonimages
                                        //      blabla.. you get the point..
                                                char *my_buddy_image = set_getstr( gc->irc, "msn_images_mybuddyimage" );
                                                if( access( my_buddy_image, R_OK ) == 0 )
                                                {
                                                        packet->next_step_on_ack = DATA_PREP;
                                                        packet->filename = g_strdup( my_buddy_image );
	                 		        	packet->branch = g_strdup( branch );
        		              			packet->call_id = g_strdup( call_id );
	        	                		packet->cseq = atoi( cseq );
	        	                		packet->type = TYPE_BUDDY_IMAGE; // we don't support sending emoticons so this is ok for now ...
                                                        p2p_send200ok( sb, packet, packet );
                                                        debug( "Sent 200 OK message" );
                                                }
                                                else
                                                {
                                                        debug( "Buddy Image not sent!!" );
                                                        do_error_dialog( gc, "Buddy image not sent!", "MSN");
                                                        // todo: send an error back instead of leaving the session unterminated!
                                                }
                                        } else
                                        
                                        if( !strncmp( appid, "2", 1 ) )
                                        {
                                        // todo: for filetransfers the INVITE message kan have a totalsize != length
                                        //       because the preview data is at the context field
                                        //       therefor we need to concatenate INVITE messages until offset+length = totalsize
                                        //       before parsing the invite message
                                        //       YOU NEED TO FIX THAT *BEFORE* starting to implement the filetransfer code
                                                do_error_dialog( gc, "TODO: Complete filetransfer code!", "MSN" );
                                        }
                                }
        
                                if( appid )
                                        g_free( appid );
                                if( context )
                                        g_free( context );
                                if( eufguid )
                                        g_free( eufguid );
                        }
                }
                
                if( session_id )
                        g_free( session_id );
                if( dest )
                        g_free( dest );
                if( branch )
                        g_free( branch );
                if( call_id )
                        g_free( call_id );
                if( cseq )
                        g_free( cseq );
                if( content_type )
                        g_free( content_type );
        } else 
        
	/* If this is a 200 OK response */
        if( !strncmp( packet->data, "MSNSLP/1.0 200 OK", strlen( "MSNSLP/1.0 200 OK" ) ) )
        {
                char *call_id = p2p_findheader( packet, "Call-ID: {" );
                if( call_id )
                {
                        call_id[strlen( call_id )-1]=0;
                        
                        tmp_packet = p2p_find_packet_by_callid( sb, call_id );
                        if( tmp_packet )
                        {
                                debug( "200 OK message received. Sending an ACK" );
                                p2p_sendack( sb, tmp_packet, packet );
                                tmp_packet->header.session_id = tmp_packet->session_id;
                        }
                        else
                        {
                                debug( "200 OK message received but i don't have a session for it... Ignoring!" );
                        }

                        g_free( call_id );
                }
	} else 
	
        /* If this is a BYE response */
        if( !strncmp( packet->data, "BYE MSNMSGR:", strlen( "BYE MSNMSGR:" ) ) )
        {
                debug( "BYE message received." );
                char *call_id = p2p_findheader( packet, "Call-ID: {" );
                if( call_id )
                {
                        call_id[strlen( call_id )-1]=0;
                        
                        struct P2PPacket *tmp_packet = p2p_find_packet_by_callid( sb, call_id );
                        if( tmp_packet )
                        {
                                debug( "Sending an ACK + BYE message + deleting the session!" );
                                tmp_packet->header.session_id = 0;
                                p2p_sendack( sb, tmp_packet, packet );

                                p2p_cleanup_packet( tmp_packet );                                
                                sb->p2p_sessionlist = g_slist_remove( sb->p2p_sessionlist, tmp_packet );
                        }
                        else
                        {
                                debug( "I don't expect a BYE message. Ignoring message" );
                        }
                        
                        g_free( call_id );
                }
        } else
        
        /* MSN Messenger 6.2 sends a message back with flag being 0x40
         * right after downloading our buddy image. I can't find any
         * '3rd-party documentation' about that flag but everything seems
         * to be working so i guess it's a normal thing?
         * If you know more about that flag: I'm interested to know about it!
         * (maybe there's an error in any of my packets and 0x40 means ERROR?)
         */
        if( packet->header.flags == 0x40 )
        {
                /* IGNORE */
        } else
        
        /* Check for data preparation / data messages packets */
        if( packet->header.session_id != 0 )
        {
                tmp_packet = p2p_find_packet( sb, packet->header.session_id, FIND_BY_SESSION_ID );
                if( tmp_packet )
                {
                        if( packet->header.total_size == 4 && packet->header.length == 4 )
                        {
                                /* Data preparation received */
                                if( tmp_packet->filename )
                                {
                                        debug( "Data perparation received. Sending ACK..." );
                                        p2p_sendack( sb, tmp_packet, packet );
                                }
                                else
                                {
                                        debug( "Got a data preparation message but no filename to write to. THIS SHOULD'NT HAPPEN!" );
                                }
                        }
                        else
                        {
                                /* Data message received */
                                debug( "Data message ... Data is comming!!!" );
                                
                                if( tmp_packet->fd != -1 )
                                {
                                        if( write( tmp_packet->fd, packet->data, packet->header.length ) == -1 )
                                        {
                                                debug( "Error writing buddy/emoticon data! This shouldn't hapen :(" );
                                        }
                                        else
                                        {
                                                debug( "buddy/emoticon data written successfully!" );
                                        }
                                }
                                else
                                {
                                        debug( "Got a data packet but i don't have a file to write to. This should not happen!" );
                                }

                                if( packet->header.offset + packet->header.length >= packet->header.total_size )
                                {
                                      /* end of file */
                                      debug( "File receive completed!" );
                                    //  serv_got_crap( gc, "File %s received successfully!",
                                    //          tmp_packet->filename );
                                              
                                      if( tmp_packet->fd != -1 )
                                      {
                                              close( tmp_packet->fd );
                                              tmp_packet->fd = -1;
                                              
                                      }
                                      p2p_sendack( sb, tmp_packet, packet );
                                      tmp_packet->next_step_on_ack = BYEACK;
                                      p2p_sendbye( sb, tmp_packet, packet );
                                }
                        }
                }
                else
                {
                        /* SHOULD NOT HAPPEN */
                        debug( "Well this shouldn't happen, Reference: 239OJPA2" );
                }
        } else

        /* something else */
        {
                /* Unsupported? */
                debug( "received a p2p packet but don't know how to handle it (yet?)" );
        }
}
