#ifndef MSNC1
#define MSNC1

#define DWORD unsigned int
#define QWORD unsigned long long

struct P2PHeader
{
        DWORD session_id;
        DWORD id;
        QWORD offset;
        QWORD total_size;
        DWORD length;
        DWORD flags;
        DWORD ack_id;
        DWORD ack_sub_id;
        QWORD ack_size;
};

struct P2PFooter
{
        DWORD value;
};

struct P2PPacket
{
	/* msn p2p stuff */
	struct P2PHeader header;
	char data[1352]; /* max. 1202 characters ( or 1352 in case of a Direct Connection ( not even supported by now! ) ) */
	struct P2PFooter footer;
	
	/* msn slp stuff */
	char *destination, *branch, *call_id, *filename;
	int cseq, session_id;
	int type, next_step_on_ack;
	int fd;
};

enum {
        FIND_BY_SESSION_ID = 1,
        FIND_BY_ID,
};

enum {
        IGNORE = 1,
        DATA_PREP,
        SEND_DATA,
        DATA_SENT,
        BASEIDENTIFIER,
        BYEACK,
};

void msn_update_mybuddyimage( struct gaim_connection *gc );
struct msn_userinfo *msn_find_userinfo( struct msn_data *md, char *who );
void msn_cleanup_userinfo( struct msn_userinfo *userinfo );
void msn_cleanup_userinfolist( struct msn_data *md );
void msn_add_or_update_userinfolist( struct gaim_connection *gc, struct msn_userinfo *new_userinfo );
struct msn_userinfo *userinfo_from_params( char *who, char *msnobject );
void p2p_init_random();
DWORD p2p_randomnr();
char *p2p_rand_guid();
struct P2PPacket *p2p_packet_new();
struct P2PPacket *p2p_packet_from_buffer( char *buffer, int length );
struct P2PPacket *p2p_find_packet_by_callid( struct msn_switchboard *sb, char *call_id );
struct P2PPacket *p2p_find_packet( struct msn_switchboard *sb, DWORD value, int type );
char *p2p_findheader( struct P2PPacket *packet, char *header );
void p2p_cleanup_packet( struct P2PPacket *packet );
void p2p_cleanup_sb( struct msn_switchboard *sb );
char *msn_imagefullpath( struct gaim_connection *gc, char *who, char *msnobject, int type, char *emoticon_shortcut, char *ext );
void p2p_sendpacket( struct msn_switchboard *sb, struct P2PPacket *packet );
void p2p_sendack( struct msn_switchboard *sb, struct P2PPacket *packet, struct P2PPacket *received_packet );
void p2p_sendbaseidentifier( struct msn_switchboard *sb, struct P2PPacket *packet, struct P2PPacket *received_packet );
void p2p_send200ok( struct msn_switchboard *sb, struct P2PPacket *packet, struct P2PPacket *received_packet );
void p2p_senddataprep( struct msn_switchboard *sb, struct P2PPacket *packet );
void p2p_senddata( struct msn_switchboard *sb, struct P2PPacket *packet );
void p2p_sendinvite( struct msn_switchboard *sb, struct P2PPacket *packet, char *context );
void p2p_request_msnobject( struct msn_switchboard *sb, char *destination, char *msnobject, char *emoticon_shortcut );
void p2p_sendbye( struct msn_switchboard *sb, struct P2PPacket *packet, struct P2PPacket *received_packet );
void p2p_handler( struct msn_switchboard *sb, struct P2PPacket *packet );

#endif

